
StellarTick = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "Metrognome-2.0")

function StellarTick:OnInitialize()
	local _,cls = UnitClass("player")
	if cls == "WARRIOR" then return end
	if self:BuildTick() then
		self.previousenergy = -1
		self.previousmana = 99999
		self.previoustime = 0
		if cls == "ROGUE" then 
			self:RegisterMetro("tick", self.Update, 0.03, self)
			self:RegisterEvent("UNIT_ENERGY")
			self.p = 3
		elseif cls == "DRUID" then
			self:RegisterMetro("tick", self.Update, 0.03, self)
			self:RegisterEvent("UNIT_MANA")
			self:RegisterEvent("UNIT_ENERGY")
			self:RegisterEvent("UNIT_DISPLAYPOWER", function()
				if arg1 ~= "player" then return end
				self.p = UnitPowerType("player")
				if self.p == 1 then
					self.spark:Hide()
					self.go = nil
				end
			end)
			self.p = UnitPowerType("player")
		else
			self:RegisterMetro("tick", self.Update, 0.05, self)
			self:RegisterEvent("UNIT_MANA")
			self.p = 0
		end
		self:StartMetro("tick")
	end
end

function StellarTick:BuildTick()
	if not StellarUF then return end
	self.frame = StellarUF.units.player.mp

	self.spark = self.frame:CreateTexture(nil, "OVERLAY")
	self.spark:SetTexture("Interface\\CastingBar\\UI-CastingBar-Spark")
	self.spark:SetWidth(8)
	self.spark:SetHeight(self.frame:GetHeight()*2.5)
	self.spark:SetBlendMode("ADD")
	self.spark:SetAlpha(0.6)
	return true
end

function StellarTick:UNIT_MANA()
	if arg1 ~= "player" then return end
	if UnitMana("player") < self.previousmana then 
		self.previoustime = 0 
		self.go = true
		self.spark:Show()
	end
	self.previousmana = UnitMana("player")
end

function StellarTick:UNIT_ENERGY()
	if arg1 ~= "player" then return end
	if self:IsRegenTick() then 
		self.previoustime = 0 
	end
	self.previousenergy = UnitMana("player")
end

function StellarTick:Update(difference)
	if UnitIsDeadOrGhost("player") or self.p == 1 then 
		self.spark:Hide() 
	elseif self.p == 3 then
		self.previoustime = self.previoustime + difference
		if self.previoustime > 1.99 then
			self.previoustime = 0
		end
		local perc = self.previoustime / 1.99
		self.spark:SetPoint("CENTER", self.frame, "LEFT", perc*self.frame:GetWidth(), 0)
		self.spark:SetAlpha(perc)
		self.spark:Show()
	elseif self.go and self.p == 0 then
		self.previoustime = self.previoustime + difference
		if self.previoustime > 5 then
			self.spark:Hide()
			self.go = nil
		else
			local perc = self.previoustime / 5
			self.spark:SetPoint("CENTER", self.frame, "LEFT", perc*self.frame:GetWidth(), 0)
			self.spark:SetAlpha(perc)
		end
	end
end

-- some cheap logic to detect if an energy increase was a regen tick
function StellarTick:IsRegenTick()
	-- only regen that ticks for exactly 20 in combat
	if InCombatLockdown() and UnitMana("player") ~= UnitManaMax("player") and UnitMana("player") == (self.previousenergy + 20) then 
		return true 
	end
	-- any regen outside of combat 
	if not InCombatLockdown() and UnitMana("player") > self.previousenergy then 
		return true 
	end
	
	return false
end